gtk3-0.15.10: Binding to the Gtk+ 3 graphical user interface library

Maintainer | gtk2hs-users@lists.sourceforge.net
Stability | provisional
Portability | portable (depends on GHC)
Safe Haskell | None
Language | Haskell98

Graphics.UI.Gtk.Embedding.Socket

Contents

- Detail
- Class Hierarchy
- Types
- Constructors
- Methods
- Signals
- Deprecated

Description

Container for widgets from other processes

Synopsis

- data Socket
- class ContainerClass o => SocketClass o
- castToSocket :: GObjectClass obj => obj -> Socket
- gTypeSocket :: GType
- toSocket :: SocketClass o => o -> Socket
- data NativeWindowId
- socketNew :: IO Socket
- socketHasPlug :: SocketClass s => s -> IO Bool
- socketAddId :: SocketClass self => self -> NativeWindowId -> IO ()
- socketGetId :: SocketClass self => self -> IO NativeWindowId
- socketGetPlugWindow :: SocketClass self => self -> IO (Maybe DrawWindow)
- socketPlugAdded :: SocketClass self => Signal self (IO ())
- socketPlugRemoved :: SocketClass self => Signal self (IO Bool)

# Detail

Together with `Plug`, `Socket` provides the ability to embed widgets from one process into another process in a fashion that is transparent to the user. One process creates a `Socket` widget and, passes the that widget's window ID to the other process, which then creates a `Plug` with that window ID. Any widgets contained in the `Plug` then will appear inside the first applications window.

The socket's window ID is obtained by using `socketGetId`. Before using this function, the socket must have been realized, and for hence, have been added to its parent.

- Obtaining the window ID of a socket.

    socket <- socketNew
    widgetShow socket
    containerAdd parent socket

    -- The following call is only necessary if one of
    -- the ancestors of the socket is not yet visible.
    --
    widgetRealize socket
    socketId <- socketGetId socket
    putStrLn ("The ID of the sockets window is " ++ show socketId)

Note that if you pass the window ID of the socket to another process that will create a plug in the socket, you must make sure that the socket widget is not destroyed until that plug is created. Violating this rule will cause unpredictable consequences, the most likely consequence being that the plug will appear as a separate toplevel window. You can check if the plug has been created by calling `socketHasPlug`. If this returns `True`, then the plug has been successfully created inside of the socket.

When Gtk+ is notified that the embedded window has been destroyed, then it will destroy the socket as well. You should always, therefore, be prepared for your sockets to be destroyed at any time when the main event loop is running.

The communication between a `Socket` and a `Plug` follows the XEmbed protocol. This protocol has also been implemented in other toolkits, e.g. Qt, allowing the same level of integration when embedding a Qt widget in Gtk+ or vice versa.

# Class Hierarchy

    | GObject
    | +----Object
    | +----Widget
    | +----Container
    | +----Socket

# Types

data Socket Source #

#### Instances

Instances details

Eq Socket Source # |
Instance details Defined in Graphics.UI.Gtk.Embedding.Types Methods (==) :: Socket -> Socket -> Bool Source # (/=) :: Socket -> Socket -> Bool Source #
Ord Socket Source # |
Instance details Defined in Graphics.UI.Gtk.Embedding.Types Methods compare :: Socket -> Socket -> Ordering Source # (<) :: Socket -> Socket -> Bool Source # (<=) :: Socket -> Socket -> Bool Source # (>) :: Socket -> Socket -> Bool Source # (>=) :: Socket -> Socket -> Bool Source # max :: Socket -> Socket -> Socket Source # min :: Socket -> Socket -> Socket Source #
GObjectClass Socket Source # |
Instance details Defined in Graphics.UI.Gtk.Embedding.Types Methods toGObject :: Socket -> GObject Source # unsafeCastGObject :: GObject -> Socket Source #
SocketClass Socket Source # |
Instance details Defined in Graphics.UI.Gtk.Embedding.Types
ContainerClass Socket Source # |
Instance details Defined in Graphics.UI.Gtk.Embedding.Types
WidgetClass Socket Source # |
Instance details Defined in Graphics.UI.Gtk.Embedding.Types

class ContainerClass o => SocketClass o Source #

#### Instances

Instances details

SocketClass Socket Source # |
Instance details Defined in Graphics.UI.Gtk.Embedding.Types

castToSocket :: GObjectClass obj => obj -> Socket Source #

gTypeSocket :: GType Source #

toSocket :: SocketClass o => o -> Socket Source #

data NativeWindowId Source #

The identifier of a window of the underlying windowing system.

#### Instances

Instances details

Show NativeWindowId Source # |
Instance details Defined in Graphics.UI.Gtk.General.Structs Methods showsPrec :: Int -> NativeWindowId -> ShowS Source # show :: NativeWindowId -> String Source # showList :: [NativeWindowId] -> ShowS Source #
Eq NativeWindowId Source # |
Instance details Defined in Graphics.UI.Gtk.General.Structs Methods (==) :: NativeWindowId -> NativeWindowId -> Bool Source # (/=) :: NativeWindowId -> NativeWindowId -> Bool Source #

# Constructors

socketNew :: IO Socket Source #

Create a new empty `Socket`.

`Socket` is a `Container` for foreign applications that support the XEMBED protocol. To connect two applications the `NativeWindowId` has to be passed either from this socket to the other application's `Plug` or vice versa.

# Methods

socketHasPlug :: SocketClass s => s -> IO Bool Source #

socketAddId Source #

Arguments

:: SocketClass self |
=> self |
-> NativeWindowId | `windowId` - the window ID of a client participating in the XEMBED protocol.
-> IO () |

Adds an XEMBED client, such as a `Plug`, to the `Socket`. The client may be in the same process or in a different process.

To embed a `Plug` in a `Socket`, you can either create the `Plug` with `Graphics.UI.Gtk.Embedding.Plug.plugNew Nothing`, call `plugGetId` to get the window ID of the plug, and then pass that to the `socketAddId`, or you can call `socketGetId` to get the window ID for the socket, and call `plugNew` passing in that ID.

The `Socket` must have already be added into a toplevel window before you can make this call.

socketGetId :: SocketClass self => self -> IO NativeWindowId Source #

Gets the window ID of a `Socket` widget, which can then be used to create a client embedded inside the socket, for instance with `plugNew`.

The `Socket` must have already be added into a toplevel window before you can make this call.

socketGetPlugWindow Source #

Arguments

:: SocketClass self |
=> self |
-> IO (Maybe DrawWindow) | returns the window of the plug if available, or Nothing

Retrieves the window of the plug. Use this to check if the plug has been created inside of the socket.

- Available since Gtk+ version 2.14

# Signals

socketPlugAdded :: SocketClass self => Signal self (IO ()) Source #

This signal is emitted when a client is successfully added to the socket.

socketPlugRemoved :: SocketClass self => Signal self (IO Bool) Source #

This signal is emitted when a client is removed from the socket. The default action is to destroy the `Socket` widget, so if you want to reuse it you must add a signal handler that returns `True`.

# Deprecated